<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.14" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__hal__system" kind="group">
    <compoundname>group_hal_system</compoundname>
    <title>System</title>
      <sectiondef kind="enum">
      <memberdef id="group__group__hal__system_1ga53ba6a7416574a1b03890d23b7a90264" kind="enum" prot="public" static="no" strong="no">
        <type />
        <name>cyhal_reset_reason_t</name>
        <enumvalue id="group__group__hal__system_1gga53ba6a7416574a1b03890d23b7a90264a95a4c3cce365341fe7bca673720a2d93" prot="public">
          <name>CYHAL_SYSTEM_RESET_NONE</name>
          <initializer>= 0</initializer>
          <briefdescription>
<para>No cause. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__system_1gga53ba6a7416574a1b03890d23b7a90264a28d2eb1bf90f731f930c487d8dcd8079" prot="public">
          <name>CYHAL_SYSTEM_RESET_WDT</name>
          <initializer>= 1 &lt;&lt; 0</initializer>
          <briefdescription>
<para>A watchdog timer (WDT) reset has occurred. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__system_1gga53ba6a7416574a1b03890d23b7a90264aa852e5ed7f6785de64f75f6d8f0a2994" prot="public">
          <name>CYHAL_SYSTEM_RESET_ACTIVE_FAULT</name>
          <initializer>= 1 &lt;&lt; 1</initializer>
          <briefdescription>
<para>The fault logging system requested a reset from its Active logic. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__system_1gga53ba6a7416574a1b03890d23b7a90264adf8b1ade858c21843b064b7bb9d1ad74" prot="public">
          <name>CYHAL_SYSTEM_RESET_DEEPSLEEP_FAULT</name>
          <initializer>= 1 &lt;&lt; 2</initializer>
          <briefdescription>
<para>The fault logging system requested a reset from its Deep-Sleep logic. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__system_1gga53ba6a7416574a1b03890d23b7a90264a27e1581bf176b0b216c7bb9266a88a2d" prot="public">
          <name>CYHAL_SYSTEM_RESET_SOFT</name>
          <initializer>= 1 &lt;&lt; 3</initializer>
          <briefdescription>
<para>The CPU requested a system reset through it's SYSRESETREQ. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__system_1gga53ba6a7416574a1b03890d23b7a90264a2d37ff7de305fafa5efd82851b10f9f8" prot="public">
          <name>CYHAL_SYSTEM_RESET_HIB_WAKEUP</name>
          <initializer>= 1 &lt;&lt; 4</initializer>
          <briefdescription>
<para>A reset has occurred due to a a wakeup from hibernate power mode. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__system_1gga53ba6a7416574a1b03890d23b7a90264a9f7bc88bd31996816b0c87e66b6ed3ab" prot="public">
          <name>CYHAL_SYSTEM_RESET_WCO_ERR</name>
          <initializer>= 1 &lt;&lt; 5</initializer>
          <briefdescription>
<para>A reset has occurred due to a watch-crystal clock error. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__system_1gga53ba6a7416574a1b03890d23b7a90264a47ca71b4cbbccce8cce116e61d5054c0" prot="public">
          <name>CYHAL_SYSTEM_RESET_SYS_CLK_ERR</name>
          <initializer>= 1 &lt;&lt; 6</initializer>
          <briefdescription>
<para>A reset has occurred due to a system clock error. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__system_1gga53ba6a7416574a1b03890d23b7a90264a2ed57102eaf30e7b73e04b380d8abe10" prot="public">
          <name>CYHAL_SYSTEM_RESET_PROTECTION</name>
          <initializer>= 1 &lt;&lt; 7</initializer>
          <briefdescription>
<para>A reset has occurred due to a protection violation. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <briefdescription>
<para><bold>cyhal_reset_reason_t: </bold><linebreak />Flags enum of possible system reset causes.</para></briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="90" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_system.h" bodystart="79" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_system.h" line="80" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__group__hal__system_1ga70a306e5108a38aa995c0ab7d0147e43" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>uint32_t</type>
        <definition>uint32_t cyhal_system_critical_section_enter</definition>
        <argsstring>(void)</argsstring>
        <name>cyhal_system_critical_section_enter</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
<para>Enter a critical section. </para>        </briefdescription>
        <detaileddescription>
<para>Disables interrupts and returns a value indicating whether the interrupts were previously enabled.</para><para><simplesect kind="return"><para>Returns the state before entering the critical section. This value must be provided to <ref kindref="member" refid="group__group__hal__system_1ga9fe83f08f46b64c956ec7ed3c335f659">cyhal_system_critical_section_exit()</ref> to properly restore the state</para></simplesect>
See <ref kindref="member" refid="group__group__hal__system_1subsection_system_snippet1">Snippet 1: Critical Section</ref> for code snippet on critical section </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_system.h" line="102" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__system_1ga9fe83f08f46b64c956ec7ed3c335f659" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_system_critical_section_exit</definition>
        <argsstring>(uint32_t old_state)</argsstring>
        <name>cyhal_system_critical_section_exit</name>
        <param>
          <type>uint32_t</type>
          <declname>old_state</declname>
        </param>
        <briefdescription>
<para>Exit a critical section. </para>        </briefdescription>
        <detaileddescription>
<para>Re-enables the interrupts if they were enabled before <ref kindref="member" refid="group__group__hal__system_1ga70a306e5108a38aa995c0ab7d0147e43">cyhal_system_critical_section_enter()</ref> was called. The argument should be the value returned from <ref kindref="member" refid="group__group__hal__system_1ga70a306e5108a38aa995c0ab7d0147e43">cyhal_system_critical_section_enter()</ref>.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">old_state</parametername>
</parameternamelist>
<parameterdescription>
<para>The state of interrupts from <ref kindref="member" refid="group__group__hal__system_1ga70a306e5108a38aa995c0ab7d0147e43">cyhal_system_critical_section_enter()</ref></para></parameterdescription>
</parameteritem>
</parameterlist>
See <ref kindref="member" refid="group__group__hal__system_1subsection_system_snippet1">Snippet 1: Critical Section</ref> for code snippet on critical section </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_system.h" line="114" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__system_1ga5f450769c1207d98134a9ced39adfdda" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_system_delay_ms</definition>
        <argsstring>(uint32_t milliseconds)</argsstring>
        <name>cyhal_system_delay_ms</name>
        <param>
          <type>uint32_t</type>
          <declname>milliseconds</declname>
        </param>
        <briefdescription>
<para>Requests that the current operation delays for at least the specified length of time. </para>        </briefdescription>
        <detaileddescription>
<para>If this is running in an RTOS aware environment (COMPONENTS+=RTOS_AWARE) or (DEFINES+=CY_RTOS_AWARE) it will attempt to have the RTOS suspend the current task so others can continue to run. If this is not run under an RTOS it will then defer to the standard system delay which is likely to be a busy loop. If this is part of an application that is build with RTOS awareness, but the delay should not depend on the RTOS for whatever reason, use <ref kindref="member" refid="group__group__hal__system_1ga25235eff5e6695bfdcc9943e7095a83b">cyhal_system_delay_us()</ref> with the appropriate 1000x multiplier to the delay time.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">milliseconds</parametername>
</parameternamelist>
<parameterdescription>
<para>The number of milliseconds to delay for </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Returns CY_RSLT_SUCCESS if the delay request was successful, otherwise error </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_system.h" line="129" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__system_1ga25235eff5e6695bfdcc9943e7095a83b" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_system_delay_us</definition>
        <argsstring>(uint16_t microseconds)</argsstring>
        <name>cyhal_system_delay_us</name>
        <param>
          <type>uint16_t</type>
          <declname>microseconds</declname>
        </param>
        <briefdescription>
<para>Requests that the current operation delay for at least the specified number of micro-seconds. </para>        </briefdescription>
        <detaileddescription>
<para>This will generally keep the processor active in a loop for the specified length of time. If this is running under an RTOS, it will NOT attempt to run any other RTOS tasks, however if the scheduler or a high priority interrupt comes it they can take over anyway.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">microseconds</parametername>
</parameternamelist>
<parameterdescription>
<para>The number of micro-seconds to delay for </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_system.h" line="140" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__system_1ga9a7b601e0b06a896860f411103a4abc6" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__hal__system_1ga53ba6a7416574a1b03890d23b7a90264">cyhal_reset_reason_t</ref></type>
        <definition>cyhal_reset_reason_t cyhal_system_get_reset_reason</definition>
        <argsstring>(void)</argsstring>
        <name>cyhal_system_get_reset_reason</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
<para>Gets the cause of the latest reset or resets that occurred in the system. </para>        </briefdescription>
        <detaileddescription>
<para><simplesect kind="return"><para>Returns an enum of flags with the cause of the last reset(s)</para></simplesect>
Refer <ref kindref="member" refid="group__group__hal__system_1subsection_system_snippet2">Snippet 2: Reset reason</ref> for code snippet on cyhal_system_get_reset_reason </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_system.h" line="148" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__system_1ga9a935d5e4f43343e7bbb4f9a86a10df0" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_system_clear_reset_reason</definition>
        <argsstring>(void)</argsstring>
        <name>cyhal_system_clear_reset_reason</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
<para>Clears the reset cause registers. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_system.h" line="151" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>High level interface for interacting with reset and delays. </para>    </briefdescription>
    <detaileddescription>

<para><heading level="1">Features</heading></para>
<para>This driver provides three categories of functionality:<itemizedlist>
<listitem><para>Ability to get the last reset reason.</para></listitem><listitem><para>Ability to delay for a period of time.</para></listitem><listitem><para>The ability to disable interrupts during a critical section.</para></listitem></itemizedlist>
</para>

<para><heading level="1">Quick Start</heading></para>
<para><itemizedlist>
<listitem><para><ref kindref="member" refid="group__group__hal__system_1ga70a306e5108a38aa995c0ab7d0147e43">cyhal_system_critical_section_enter</ref> and <ref kindref="member" refid="group__group__hal__system_1ga9fe83f08f46b64c956ec7ed3c335f659">cyhal_system_critical_section_exit</ref> are used to enable/disable global interrupts</para></listitem><listitem><para><ref kindref="member" refid="group__group__hal__system_1ga5f450769c1207d98134a9ced39adfdda">cyhal_system_delay_ms</ref> and <ref kindref="member" refid="group__group__hal__system_1ga25235eff5e6695bfdcc9943e7095a83b">cyhal_system_delay_us</ref> are delay functions used to halt the CPU exectution for a specified period of time</para></listitem><listitem><para><ref kindref="member" refid="group__group__hal__system_1ga9a7b601e0b06a896860f411103a4abc6">cyhal_system_get_reset_reason</ref> gets the cause of latest system reset and <ref kindref="member" refid="group__group__hal__system_1ga9a935d5e4f43343e7bbb4f9a86a10df0">cyhal_system_clear_reset_reason</ref> clears the reset cause registers</para></listitem></itemizedlist>
</para>

<para><heading level="1">Code Snippets</heading></para>

<para><bold>Snippet 1: Critical Section</bold></para>
<para>Critical section is a portion in the code where all active interrupts are disabled. This is usually provided in places where the code execution must not be disturbed by an interrupt. An example is a firmware controlled communication protocol where timing of each byte must be maintained and any interrupt might cause loss of data. <linebreak />
 <ref kindref="member" refid="group__group__hal__system_1ga70a306e5108a38aa995c0ab7d0147e43">cyhal_system_critical_section_enter</ref> returns the current state of interrupts which denote the active interrupts in the system. This must be passed as argument to <ref kindref="member" refid="group__group__hal__system_1ga9fe83f08f46b64c956ec7ed3c335f659">cyhal_system_critical_section_exit</ref> while exiting the critical section. <programlisting filename="system.c"><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Disables<sp />all<sp />interrupts<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />state<sp />=<sp /><ref kindref="member" refid="group__group__hal__system_1ga70a306e5108a38aa995c0ab7d0147e43">cyhal_system_critical_section_enter</ref>();</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Application<sp />code<sp />where<sp />interrupts<sp />must<sp />be<sp />disabled<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Re-enable<sp />all<sp />interrupts<sp />that<sp />were<sp />enabled<sp />before<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__system_1ga9fe83f08f46b64c956ec7ed3c335f659">cyhal_system_critical_section_exit</ref>(state);</highlight></codeline>
</programlisting> </para>

<para><bold>Snippet 2: Reset reason</bold></para>
<para><ref kindref="member" refid="group__group__hal__system_1ga9a7b601e0b06a896860f411103a4abc6">cyhal_system_get_reset_reason</ref> must be called at the beginning of the main to determine the reason for reset. The return parameters are present in <ref kindref="member" refid="group__group__hal__system_1ga53ba6a7416574a1b03890d23b7a90264">cyhal_reset_reason_t</ref>. <programlisting filename="system.c"><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__hal__system_1gga53ba6a7416574a1b03890d23b7a90264a28d2eb1bf90f731f930c487d8dcd8079">CYHAL_SYSTEM_RESET_WDT</ref><sp />==<sp /><ref kindref="member" refid="group__group__hal__system_1ga9a7b601e0b06a896860f411103a4abc6">cyhal_system_get_reset_reason</ref>())</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />WDT<sp />caused<sp />system<sp />reset<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Application<sp />code<sp />to<sp />perform<sp />some<sp />action<sp />to<sp />indicate</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />that<sp />WDT<sp />caused<sp />the<sp />interrupt</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Clear<sp />the<sp />reset<sp />reason<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__system_1ga9a935d5e4f43343e7bbb4f9a86a10df0">cyhal_system_clear_reset_reason</ref>();</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Reset<sp />reason<sp />is<sp />not<sp />WDT</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />Could<sp />be<sp />POR<sp />or<sp />XRES.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />Specify<sp />application<sp />code<sp />to<sp />perform<sp />some<sp />action<sp />to<sp />indicate</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />WDT<sp />was<sp />not<sp />the<sp />reset<sp />reaon</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
</programlisting></para>

    </detaileddescription>
  </compounddef>
</doxygen>